/*
 * @Author: ZhengXiaowei
 * @Date: 2019-10-15 12:06:28
 * @LastEditors: ZhengXiaowei
 * @LastEditTime: 2019-10-15 14:32:19
 * @Description: api 配置入口
 */
import fetch from "@system.fetch";
import Fly from "flyio/dist/npm/hap";
import apiConfig from "./config";
import prompt from '@system.prompt';
import { getToken, clearToken, getSendOrderId } from "./utils";
import it from "../helper/interface.js";
var fly = new Fly(fetch);
var qs = require('qs');
var appInfo = it.getAppInfo();
var appDev, sendOrderId;
var packages = 'com.beidao.kuaiying.zsy';
var requestTime = '';

it.getAppDev((res) => {
  appDev = res;
})
getSendOrderId((id) => {
  sendOrderId = id;
})

fly.config.baseURL = apiConfig.baseURL;
fly.config.headers["Content-Type"] =
  "application/x-www-form-urlencoded;charset=utf-8";

const filterNoToken = ["/login", "/refreshToken"];
let requestList = [];

const isSameRequest = async (url) =>{
  let lastUrl = requestList[requestList.length-1] || '';
  if( lastUrl = url && (new Date().getTime()-requestTime)/1000 < 2 ){
    console.log('间隔真的太短了啦')
    return false;
  }else{
    requestList.push(url);
    if(requestList.length>8){
      requestList.shift()
    }
    return true;
  }
}

fly.interceptors.request.use(async config => {
  // 过滤一些不需要登录的路由d
  if (filterNoToken.indexOf(config.url) === -1) {
    let token = await getToken();
    if (config.headers) {
      config.headers.Authorization = token;
      config.headers["X-Version"] = appInfo.versionName;
      config.headers["X-Brand"] = qs.stringify(appDev);
      config.headers["X-Package"] = packages;
      if (sendOrderId) config.headers["send-order-id"] = sendOrderId;
    }
    else {
      if (sendOrderId) {
        config.headers = { Authorization: token, 'X-Version': appInfo.versionName, 'X-Brand': qs.stringify(appDev),"X-Package":packages, 'send-order-id': sendOrderId };
      } else {
        config.headers = { Authorization: token, 'X-Version': appInfo.versionName, 'X-Brand': qs.stringify(appDev),"X-Package":packages };
      }
    }
    if (config.method === "POST") {
      if(qs.stringify(config.body)){
        config.body = qs.stringify(config.body) + '&package=' + packages;
      }else{
        config.body = 'package=' + packages
      }
      console.log(config.body)
    }else{
      config.body? config.body.package = packages : config.body = {package: packages}
    }
    return config;
  } else{
    if(!isSameRequest(config.url)){
        return false;
    }else{
      requestTime = new Date().getTime();
      return config;
    }
   
  } 
});

fly.interceptors.response.use(
  async res => {
    if (!res.data.code) {
      return res.data.data;
    } else if (res.data.code === 10023 || res.data.code === 10001) {
      // token失效
      await clearToken();
      console.log("begin refresh token");
      let refresh_token = await getToken();
      console.log("refresh token:", refresh_token);
      return fly(res.config);
      // return getToken().then(token => {
      // });
    }
    else {
      prompt.showToast({
        message: res.data.msg
      })
      return Promise.reject(res);
    }
  },
  err => {
    console.log('err', err)
    return Promise.reject(err);
  }
);

export default fly;
